;
;DDUMP.H V0.00
;(C)1996,1997,2013 wnc develop
;
;    1995. 8.14(MON)
;rev 1996. 5.25(THU)
;rev 1997. 6.16(MON)sv@\폜
;rev 2013.10.20(SUN)
;-----------------
;
;CZX(QBSDX^CCZXj
;2013N10 wnc develop
;---------------------------------------------------------
;Copyright (c) 1996,1997,2013 wnc / t.w.
;All rights reserved.
;
;Redistribution and use in source and binary forms,
; with or without modification, are permitted provided that 
;the following conditions are met:
;
;1. Redistributions of source code must retain the above copyright notice,
;   this list of conditions and the following disclaimer.
;2. Redistributions in binary form must reproduce the above copyright notice,
;   this list of conditions and the following disclaimer in
;   the documentation and/or other materials provided with the distribution.
;
;THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
; "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
; BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
; AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
; IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
; ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
; DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
; GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
; (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
; USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;---------------------------------------------------------
;equ
STOP	EQU	03H
LF	EQU	0AH
CR	EQU	0DH
ESC_	EQU	1BH
;
OFS	EQU	OFFSET
BYTP	EQU	BYTE PTR
WORP	EQU	WORD PTR
;
;-----------------
;MACRO
;-----------------
;DOBLE INC
WINC	MACRO	REG
	INC	REG
	INC	REG
	ENDM
;---------
;DOBLE DEC
WDEC	MACRO	REG
	DEC	REG
	DEC	REG
	ENDM
;---------
;PUSH ALL X
PUSHX	MACRO
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	ENDM
;---------
;POP ALL X
POPX	MACRO
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	ENDM
;---------
;PUSH SI DI
PUSHI	MACRO
	PUSH	SI
	PUSH	DI
	ENDM
;---------
;POP DI SI
POPI	MACRO
	POP	DI
	POP	SI
	ENDM
;---------
;PROGRAM END
ERREND	MACRO
	MOV	AL,00H
	MOV	AH,4CH
	INT	21H
	ENDM
;
;---------
;LONG JUMP NO ZERO
LJNZ	MACRO	ADDR
	LOCAL	LJNZE
	JZ	LJNZE
	JMP	ADDR
LJNZE:
	ENDM
;---------
;LONG JUMP ZERO
LJZ	MACRO	ADDR
	LOCAL	LJZE
	JNZ	LJZE
	JMP	ADDR
LJZE:
	ENDM
;---------
;LONG JUMP NO CARRY
LJNC	MACRO	ADDR
	LOCAL	LJNCE
	JC	LJNCE
	JMP	ADDR
LJNCE:
	ENDM
;---------
;LONG JUMP CARRY
LJC	MACRO	ADDR
	LOCAL	LJCE
	JNC	LJCE
	JMP	ADDR
LJCE:
	ENDM
;---------
;EXT CALL (Z frag)
;951220
CALLZ	MACRO	ADDR
	LOCAL	CZE
	JNZ	CZE
	CALL	ADDR
CZE:
	ENDM
;//////
;951220
CALLNZ	MACRO	ADDR
	LOCAL	CNZE
	JZ	CNZE
	CALL	ADDR
CNZE:
	ENDM
;---------
;EXT CALL (C frag)
;951220
CALLC	MACRO	ADDR
	LOCAL	CCE
	JNC	CCE
	CALL	ADDR
CCE:
	ENDM
;//////
;951220
CALLNC	MACRO	ADDR
	LOCAL	CNCE
	JC	CNCE
	CALL	ADDR
CNCE:
	ENDM
;
;--------------------
;MACRO2
;--------------------
;
;KILL KEY BUFFER
KILKBUF	MACRO
	PUSHF
	PUSH	AX
	MOV	AX,0C00H	;AH=0CH,AL=00H
	INT	21H
	POP	AX
	POPF
	ENDM
;
;OUT PUT BEEP
BEEP	MACRO
	PUSH	AX
	MOV	AL,07H
	INT	29H
	POP	AX
	ENDM
;
;PRINT	OFSADDR
;OUT PUT 
PRINT	MACRO	OFSADDR
	PUSH	AX
	PUSH	DX
	MOV	AH,09H
	MOV	DX,offset OFSADDR
	INT	21H
	POP	DX
	POP	AX
	ENDM
;
;<960226>
PUTCHAR	MACRO	CHR
	PUSHF
	PUSH	AX
	MOV	AL,CHR
	INT	29H
	POP	AX
	POPF
	ENDM
;
;<970623>
PUTC	MACRO	CHAR
	PUSH	AX
	PUSH	DX
	MOV	AH,02H
	MOV	DL,CHAR
	INT	21H
	POP	DX
	POP	AX
	ENDM
;
;
;<961105>
PUTC_DX	MACRO
	PUSH	AX
	MOV	AX,DX
	PUTC_AX
	POP	AX
	ENDM
;
;<961105>
PUTC_CX	MACRO
	PUSH	AX
	MOV	AX,CX
	PUTC_AX
	POP	AX
	ENDM
;
;<961105>
PUTC_BX	MACRO
	PUSH	AX
	MOV	AX,BX
	PUTC_AX
	POP	AX
	ENDM
;
;<961105>
PUTC_AX	MACRO
	PUSH	AX
	XCHG	AH,AL
	PUTC_AL2
	XCHG	AH,AL
	PUTC_AL
	POP	AX
	ENDM
;
;<961105>
PUTC_AL2	MACRO
	LOCAL	P_J1,P_J2
	PUSHF
	PUSH	AX
	MOV	AH,AL
	SHR	AL,1
	SHR	AL,1
	SHR	AL,1
	SHR	AL,1
	ADD	AL,30H
	CMP	AL,3AH
	JC	P_J2
	ADD	AL,07H
P_J2:	INT	29H
	MOV	AL,AH
	AND	AL,0FH
	ADD	AL,30H
	CMP	AL,3AH
	JC	P_J1
	ADD	AL,07H
P_J1:	INT	29H
	POP	AX
	POPF
	ENDM
;
;
;<960226>
PUTC_AL	MACRO
	LOCAL	P_J1,P_J2
	PUSHF
	PUSH	AX
	MOV	AH,AL
	SHR	AL,1
	SHR	AL,1
	SHR	AL,1
	SHR	AL,1
	ADD	AL,30H
	CMP	AL,3AH
	JC	P_J2
	ADD	AL,07H
P_J2:	INT	29H
	MOV	AL,AH
	AND	AL,0FH
	ADD	AL,30H
	CMP	AL,3AH
	JC	P_J1
	ADD	AL,07H
P_J1:	INT	29H
	MOV	AL,CR
	INT	29H
	MOV	AL,LF
	INT	29H
	POP	AX
	POPF
	ENDM
;
;<960226>
GETC_AL	MACRO
	PUSH	DX
	MOV	DH,AH
	MOV	AH,06H
	MOV	DL,0FFH
	INT	21H
	MOV	AH,DH
	POP	DX
	ENDM
;
;HEAD END.
;
